unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,  ProDlgs, ProCalc, ProCtrls, StdCtrls, GDDMatrix;

type TGDDPoint = class
    public
    x:Variant;
    y:Variant;
    constructor Create(); overload;
    end;

type TGDDEllipse=class
    public
    Centre:TGDDPoint;
    Theta,Major,Minor:Double;
    constructor Create();
	  function Interieur(const A:TGDDPoint):boolean;
    end;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    ButtonTrace: TButton;
    ButtonACP: TButton;
    ButtonAFD: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    eNbPoints: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    eX1: TEdit;
    eY1: TEdit;
    eX2: TEdit;
    eY2: TEdit;
    eMajor1: TEdit;
    eMajor2: TEdit;
    eMinor1: TEdit;
    eMinor2: TEdit;
    eTheta1: TEdit;
    eTheta2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure PaintPaint(Sender: TObject);

    procedure ButtonTraceClick(Sender: TObject);
    procedure ButtonACPClick(Sender: TObject);
    procedure ButtonAFDClick(Sender: TObject);
  public
    bmp:TBitmap;                      // Image  l'cran des 2 nuages de points
    Ellipse1,Ellipse2:TGDDEllipse;    // Ellipse dfinissant 2 nuages de points
    ListPoint1 : TList;               // Nuage de points de la premire ellipse
    ListPoint2 : TList;               // Nuage de points de la deuxime ellipse
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;

constructor TGDDPoint.Create();
begin
  x:=0;
  y:=0;
end;


constructor TGDDEllipse.Create();
begin
  Centre :=TGDDPoint.Create();
end;


function TGDDEllipse.Interieur(const A:TGDDPoint):boolean;
begin
  result :=(sqr(A.x-Centre.x) / sqr(Minor) + sqr(A.y-Centre.y)/sqr(Major)<=1);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
    randomize;
    bmp := TBitmap.Create;
    bmp.Width := PaintBox1.Width;
    bmp.Height := PaintBox1.Height;
    bmp.Canvas.MoveTo(bmp.Width div 2, 10);
    bmp.Canvas.LineTo(bmp.Width div 2, bmp.Height-10);
    bmp.Canvas.MoveTo(10,bmp.Height div 2);
    bmp.Canvas.LineTo(bmp.Width-10,bmp.Height div 2);
    Ellipse1 := TGDDEllipse.Create();
    Ellipse2 := TGDDEllipse.Create();
    ListPoint1 := TList.Create;
    ListPoint2 := TList.Create;
end;

procedure TForm1.PaintPaint(Sender: TObject);
begin
    PaintBox1.Canvas.Draw(0,0,bmp);
end;

procedure TForm1.ButtonTraceClick(Sender: TObject);
var
  i:Integer;
  LePoint:TGDDPoint;
  longueur:double;
  angle:double;
begin
    // Dfinition des 2 ellipses de nuages de points
    Ellipse1.Centre.x := strtoint(eX1.Text);
    Ellipse1.Centre.Y := strtoint(eY1.Text);
    Ellipse1.Major := strtoint(eMajor1.Text);
    Ellipse1.Minor := strtoint(eMinor1.Text);
    Ellipse1.Theta := strtofloat(eTheta1.Text);
    Ellipse2.Centre.x := strtoint(eX2.Text);
    Ellipse2.Centre.Y := strtoint(eY2.Text);
    Ellipse2.Major := strtoint(eMajor2.Text);
    Ellipse2.Minor := strtoint(eMinor2.Text);
    Ellipse2.Theta := strtofloat(eTheta2.Text);
    // On efface le bmp reprsentant l'image globale.
    bmp.Free;
    bmp := TBitmap.Create;
    bmp.Width := PaintBox1.Width;
    bmp.Height := PaintBox1.Height;


    ListPoint1.Clear;
    ListPoint2.Clear;
    // Remplissage des nuages de points. Les points sont slectionns au hasard de tel sorte
    // qu'ils soient  l'intrieur de leur ellipse respective.
    // Remplissage de ListPoint1
    for i:=0 to strtoint(eNbPoints.Text)-1 do
      begin
      LePoint := TGDDPoint.Create;
      // Slection des coordonnes du points
      LePoint.x := Ellipse1.Centre.x + random(trunc(max(Ellipse1.Major, Ellipse1.Minor))) * (-2*random(2)+1);
      LePoint.y := Ellipse1.Centre.y + random(trunc(max(Ellipse1.Major, Ellipse1.Minor))) * (-2*random(2)+1);
      while not Ellipse1.Interieur(LePoint) do
          begin
            LePoint.x := Ellipse1.Centre.x + random(trunc(max(Ellipse1.Major, Ellipse1.Minor))) * (-2*random(2)+1);
            LePoint.y := Ellipse1.Centre.y + random(trunc(max(Ellipse1.Major, Ellipse1.Minor))) * (-2*random(2)+1);
          end;
      longueur := sqrt(sqr(LePoint.x-Ellipse1.Centre.x) + sqr(Lepoint.y-Ellipse1.Centre.y));
      if LePoint.x<>Ellipse1.Centre.x then angle := arctan((LePoint.y-Ellipse1.Centre.y)/(LePoint.x-Ellipse1.Centre.x))-Ellipse1.Theta else angle := Pi/2-Ellipse1.Theta;
      If (sign(LePoint.y-Ellipse1.Centre.y)>0) then angle := angle + Pi;
      LePoint.x := longueur * cos(angle)+Ellipse1.Centre.x;
      LePoint.y := longueur * sin(angle)+Ellipse1.Centre.y;
      // On trace sur l'image le point choisi
      bmp.Canvas.Pixels[trunc(LePoint.x ),trunc(LePoint.y)] := clblue;
      bmp.Canvas.Pixels[trunc(LePoint.x -1),trunc(LePoint.y-1)] := clblue;
      bmp.Canvas.Pixels[trunc(LePoint.x -1),trunc(LePoint.y+1)] := clblue;
      bmp.Canvas.Pixels[trunc(LePoint.x +1),trunc(LePoint.y-1)] := clblue;
      bmp.Canvas.Pixels[trunc(LePoint.x +1),trunc(LePoint.y+1)] := clblue;
      ListPoint1.Add(LePoint);

      end;

  // Remplissage de ListPoint2
  for i:=0 to strtoint(eNbPoints.Text)-1 do
      begin
      LePoint := TGDDPoint.Create;;
      LePoint.x := Ellipse2.Centre.x + random(trunc(max(Ellipse2.Major, Ellipse2.Minor))) * (-2*random(2)+1);
      LePoint.y := Ellipse2.Centre.y + random(trunc(max(Ellipse2.Major, Ellipse2.Minor))) * (-2*random(2)+1);
      while not Ellipse2.Interieur(LePoint) do
          begin
            LePoint.x := Ellipse2.Centre.x + random(trunc(max(Ellipse2.Major, Ellipse2.Minor))) * (-2*random(2)+1);
            LePoint.y := Ellipse2.Centre.y + random(trunc(max(Ellipse2.Major, Ellipse2.Minor))) * (-2*random(2)+1);
          end;
      longueur := sqrt(sqr(LePoint.x-Ellipse2.Centre.x) + sqr(Lepoint.y-Ellipse2.Centre.y));
      if LePoint.x<>Ellipse2.Centre.x then angle := arctan((LePoint.y-Ellipse2.Centre.y)/(LePoint.x-Ellipse2.Centre.x))-Ellipse2.Theta else angle := Pi/2-Ellipse2.Theta;
      If (sign(LePoint.y-Ellipse2.Centre.y)>0) then angle := angle + Pi;
      LePoint.x := longueur * cos(angle)+Ellipse2.Centre.x;
      LePoint.y := longueur * sin(angle)+Ellipse2.Centre.y;
      // On trace sur l'image le point choisi
      bmp.Canvas.Pixels[trunc(LePoint.x ),trunc(LePoint.y)] := clred;
      bmp.Canvas.Pixels[trunc(LePoint.x-1 ),trunc(LePoint.y)] := clred;
      bmp.Canvas.Pixels[trunc(LePoint.x+1 ),trunc(LePoint.y)] := clred;
      bmp.Canvas.Pixels[trunc(LePoint.x),trunc(LePoint.y-1)] := clred;
      bmp.Canvas.Pixels[trunc(LePoint.x),trunc(LePoint.y+1)] := clred;
      ListPoint2.Add(LePoint);
  end;
    PaintBox1.Refresh;

end;

procedure TForm1.ButtonACPClick(Sender: TObject);
var
    Eigen:TGDDMatrix;    // matrice dans laquelle on entre toutes les coordonnes (x,y)
    EigenT:TGDDMatrix;   //  matrice transpose
    Cov:TGDDMatrix;      // matrice produit des 2 prcdentes
    i:integer;
    xmoy,ymoy:double;
    EigenVector:TGDDMatrix;    // Vecteur propre de l'axe principal
    Eigenvalue:double;          // Valeur propre de l'axe principal
begin
    // Calcul de l'axe principal indpendant de l'apartenance des points  l'un ou l'autre des nuages
    Eigen := TGDDMatrix.create(2,ListPoint1.Count+ListPoint2.Count);
    EigenT :=TGDDMatrix.create;
    Cov := TGDDMatrix.Create();
    EigenVector:=TGDDMatrix.Create();
    // On remplit la matrice Eigen avec tous les points des 2 nuages
    for i:=0 to ListPoint1.Count-1 do
        begin
        Eigen.Data[0,i] := TGDDPoint(ListPoint1[i]).x;
        Eigen.Data[1,i] := TGDDPoint(ListPoint1[i]).y;
        end;
    for i:=0 to ListPoint2.Count-1 do
        begin
        Eigen.Data[0,i+ListPoint1.Count] := TGDDPoint(ListPoint2[i]).x;
        Eigen.Data[1,i+ListPoint1.Count] := TGDDPoint(ListPoint2[i]).y;
        end;
    xmoy :=0;
    ymoy :=0;
    // On calcul le point moyen
    for i:=0 to ListPoint1.Count+ListPoint2.Count-1 do
      begin
      xmoy := xmoy + Eigen.Data[0,i];
      ymoy := ymoy + Eigen.Data[1,i];
      end;
    xmoy := xmoy /(ListPoint1.Count+ListPoint2.Count);
    ymoy := ymoy /(ListPoint1.Count+ListPoint2.Count);

    // On retranche la moyenne  tous les points pour avoir une image centre en (0,0)
    for i:=0 to ListPoint1.Count+ListPoint2.Count-1 do
      begin
      Eigen.Data[0,i] := Eigen.Data[0,i] - xmoy;
      Eigen.Data[1,i] := Eigen.Data[1,i] - ymoy;
      end;

    EigenT.Clone(Eigen);
    EigenT.Transpose;   // EigenT = Transpose(Eigen)
    Eigen.Multiply(EigenT,Cov);     // Cov = Eigen * EigenT
    Cov.SMult(1/Cov.Norme);      // On normalise Cov
    Cov.MaxEigenValVec(Eigenvalue,Eigenvector,0);   // On calcul la valeur propre et le vecteur propre associ de la matrice Cov 

    // On trace  l'cran le droite directrice de l'ACP
    bmp.Canvas.Pen.Color := clMaroon;
    bmp.Canvas.MoveTo(trunc(xmoy-200*Eigenvector.Data[0,0]),trunc(ymoy-200*Eigenvector.Data[1,0]));
    bmp.Canvas.LineTo(trunc(xmoy+200*Eigenvector.Data[0,0]),trunc(ymoy+200*Eigenvector.Data[1,0]));
    PaintBox1.Refresh;
    Eigen.Free;
    EigenT.Free;
    Cov.Free;
    Eigenvector.Free;


end;

procedure TForm1.ButtonAFDClick(Sender: TObject);
var
    Eigen1:TGDDMatrix;
    Eigen1T:TGDDMatrix;
    Eigen2:TGDDMatrix;
    Eigen2T:TGDDMatrix;
    Cov1:TGDDMatrix;
    Cov2:TGDDMatrix;
    i:Integer;
    xmoy,ymoy:double;
    xmoy1,ymoy1:double;
    xmoy2,ymoy2:double;
    EigenVector:TGDDMatrix;
    Eigenvalue:double;
    W,B:TGDDMatrix;
    Prod:TGDDMatrix;
begin
    Eigen1 := TGDDMatrix.create(2,ListPoint1.Count);
    Eigen2 := TGDDMatrix.create(2,ListPoint2.Count);
    Eigen1T :=TGDDMatrix.create;
    Eigen2T :=TGDDMatrix.create;
    Cov1 := TGDDMatrix.Create();
    Cov2 := TGDDMatrix.Create();
    W:=TGDDMatrix.create(2,2);
    B:=TGDDMatrix.create(2,2);
    EigenVector:=TGDDMatrix.Create();
    // On remplit cette fois-ci 2 matrices distincte avec les valeurs des 2 nuages
    for i:=0 to ListPoint1.Count-1 do
        begin
        Eigen1.Data[0,i] := TGDDPoint(ListPoint1[i]).x;
        Eigen1.Data[1,i] := TGDDPoint(ListPoint1[i]).y;
        end;
    for i:=0 to ListPoint2.Count-1 do
        begin
        Eigen2.Data[0,i] := TGDDPoint(ListPoint2[i]).x;
        Eigen2.Data[1,i] := TGDDPoint(ListPoint2[i]).y;
        end;
    xmoy1 :=0;
    ymoy1 :=0;
    xmoy2 :=0;
    ymoy2 :=0;
    // On calcule le point moyen (centrale) de chaque nuage de points
    // Puis on calcule la moyenne des moyennes obtenues
    for i:=0 to ListPoint1.count-1 do
      begin
      xmoy1 := xmoy1 + Eigen1.Data[0,i];
      ymoy1 := ymoy1 + Eigen1.Data[1,i];
      end;
    for i:=0 to ListPoint2.count-1 do
      begin
      xmoy2 := xmoy2 + Eigen2.Data[0,i];
      ymoy2 := ymoy2 + Eigen2.Data[1,i];
      end;
    xmoy := xmoy1 + xmoy2;
    ymoy := ymoy1 + ymoy2;
    xmoy := xmoy /(ListPoint1.Count+ListPoint2.Count);
    ymoy := ymoy /(ListPoint1.Count+ListPoint2.Count);
    xmoy1 := xmoy1 / ListPoint1.Count;
    ymoy1 := ymoy1 / ListPoint1.Count;
    xmoy2 := xmoy2 / ListPoint2.Count;
    ymoy2 := ymoy2 / ListPoint2.Count;
    // On retranche la moyenne des moyenne  chacun des points.
    for i:=0 to ListPoint1.Count-1 do
      begin
      Eigen1.Data[0,i] := Eigen1.Data[0,i] - xmoy1;
      Eigen1.Data[1,i] := Eigen1.Data[1,i] - ymoy1;
      end;
    for i:=0 to ListPoint2.Count-1 do
      begin
      Eigen2.Data[0,i] := Eigen2.Data[0,i] - xmoy2;
      Eigen2.Data[1,i] := Eigen2.Data[1,i] - ymoy2;
      end;
    B.Data[0,0] := sqr(xmoy1-xmoy)+sqr(xmoy2-xmoy);
    B.Data[0,1] := (xmoy1-xmoy)*(ymoy1-ymoy)+(xmoy2-xmoy)*(ymoy2-ymoy);
    B.Data[1,0] := (xmoy1-xmoy)*(ymoy1-ymoy)+(xmoy2-xmoy)*(ymoy2-ymoy);
    B.Data[1,1] := sqr(ymoy1-ymoy)+sqr(ymoy2-ymoy);

    Eigen1T.Clone(Eigen1);
    Eigen1T.Transpose;           // Eigen1T = Transpos(Eigen1)
    Eigen2T.Clone(Eigen1);
    Eigen2T.Transpose;           // Eigen2T = Transpos(Eigen2)
    Eigen1.Multiply(Eigen1T,Cov1);      // cov1 = Eigen1 * Eigen1T
    Eigen2.Multiply(Eigen2T,Cov2);      // cov2 = Eigen2 * Eigen1T
    W.Clone(Cov1);
    W.Add(Cov2);                     // W = Cov1 + cov2
    W.Invert;                        // W = W^-1
    Prod := TGDDMatrix.Create;
    W.Multiply(B,Prod);               // Prod = W * B
    Prod.SMult(1/Prod.Norme);
    Prod.MaxEigenValVec(Eigenvalue,Eigenvector,0);

    // Affichage  l'cran de la droite directrice de l'AFD
    bmp.Canvas.Pen.Color := clOlive;
    bmp.Canvas.MoveTo(trunc(xmoy-200*Eigenvector.Data[0,0]),trunc(ymoy-200*Eigenvector.Data[1,0]));
    bmp.Canvas.LineTo(trunc(xmoy+200*Eigenvector.Data[0,0]),trunc(ymoy+200*Eigenvector.Data[1,0]));
    PaintBox1.Refresh;
    Eigen1.Free;
    Eigen1T.Free;
    Cov1.Free;
    Eigen2.Free;
    Eigen2T.Free;
    Cov2.Free;
    Prod.Free;
    Eigenvector.Free;

end;






end.



